/*
*******************************************************
* Subroutine OPRESUT                                  *
* - Output of numerical results to a file             *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void OPRESUT(int NPOIN,double COORD[],double UPOIN[],
			 int NELEM,double CECOD[],double UCENP[],
			 double SCENP[],int NVFIX,int NPLOD,
			 int NDLEG)
{
	FILE *fp;
	extern int NTREF,NTYPE,NDIME,NDOFN,NSTRE,NNODE,
		NEDGE,NODEG,NMATS,NPROP,NGAUS;
	int iPOIN,iELEM,iDOFN,iSTRE,iDIME,n1;

	fp=fopen("Result.txt","w");
	fprintf(fp,"** Basic parameters\n");
	fprintf(fp,"\n");
	fprintf(fp,"NTREF=%5d  NTYPE=%5d\n",NTREF,NTYPE);
	fprintf(fp,"\n");
	fprintf(fp,"NDIME=%5d  NDOFN=%5d  NSTRE=%5d\n",
		NDIME,NDOFN,NSTRE);
	fprintf(fp,"\n");
	fprintf(fp,"NNODE=%5d  NEDGE=%5d  NODEG=%5d\n",
		NNODE,NEDGE,NODEG);
	fprintf(fp,"\n");
	fprintf(fp,"NMATS=%5d  NPROP=%5d  NGAUS=%5d\n",
		NMATS,NPROP,NGAUS);
	fprintf(fp,"\n");
	fprintf(fp,"NPOIN=%5d  NELEM=%5d  NVFIX=%5d\n",
		NPOIN,NELEM,NVFIX);
	fprintf(fp,"\n");
	fprintf(fp,"NPLOD=%5d  NDLEG=%5d\n",NPLOD,NDLEG);
	fprintf(fp,"\n");
	fprintf(fp,"** Nodal generalized displacements\n");
	fprintf(fp,"----------------------------------\n");
	fprintf(fp,"Num# COD#1-->#NDIME DIS#1-->#NDOFN\n");
	fprintf(fp,"----------------------------------\n");
	for(iPOIN=0;iPOIN<NPOIN;iPOIN++)
	{
		fprintf(fp,"%5d",iPOIN+1);
		for(iDIME=0;iDIME<NDIME;iDIME++)
		{
			n1=iPOIN*NDIME+iDIME;
			fprintf(fp,"  %9.4f",COORD[n1]);
		}
		for(iDOFN=0;iDOFN<NDOFN;iDOFN++)
		{
			n1=iPOIN*NDOFN+iDOFN;
			fprintf(fp,"  %9.4f",UPOIN[n1]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
	fprintf(fp,"**Central generalized displacements\n");
	fprintf(fp,"-----------------------------------\n");
	fprintf(fp,"Ele# COD#1-->#NDIME DIS#1--->#NODFN\n");
	fprintf(fp,"-----------------------------------\n");
	for(iELEM=0;iELEM<NELEM;iELEM++)
	{
		fprintf(fp,"%5d",iELEM+1);
		for(iDIME=0;iDIME<NDIME;iDIME++)
		{
			n1=iELEM*NDIME+iDIME;
			fprintf(fp,"  %9.4f",CECOD[n1]);
		}
		for(iDOFN=0;iDOFN<NDOFN;iDOFN++)
		{
			n1=iELEM*NDOFN+iDOFN;
			fprintf(fp,"  %9.4f",UCENP[n1]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
	fprintf(fp,"** Central generalized stresses\n");
	fprintf(fp,"----------------------\n");
	fprintf(fp,"Ele#  STRES#1-->#NSTRE\n");
	fprintf(fp,"----------------------\n");
	for(iELEM=0;iELEM<NELEM;iELEM++)
	{
		fprintf(fp,"%5d",iELEM+1);
		for(iSTRE=0;iSTRE<NSTRE;iSTRE++)
		{
			n1=iELEM*NSTRE+iSTRE;
			fprintf(fp,"  %9.4f",SCENP[n1]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
	return;
}