/*
*******************************************************
* Subroutine RIGIDRV                                  *
* - Recovery of rigid body motion                     *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void RIGIDRV(double ECOOD[],double c_Ele[],
			 double d_Ele[],int kTSEL,double CLENG,
			 double *c0)
{
	void DUCLEAN();
	void MATMULT();
	void TREFFTZ();
	void SCHTREF();
	extern int NTREF,NDIME,NDOFN,NNODE;
	double sum,xp,yp,*N_SET,*T_SET,*TEMP;
	int iNODE;
	sum=0.0;
	for(iNODE=0;iNODE<NNODE;iNODE++)
	{
		xp=ECOOD[iNODE*NDIME+0];
		yp=ECOOD[iNODE*NDIME+1];
		N_SET=(double *)calloc(1*NTREF,sizeof(double));
		DUCLEAN(1,NTREF,N_SET);
		T_SET=(double *)calloc(2*NTREF,sizeof(double));
		DUCLEAN(2,NTREF,T_SET);
		if(kTSEL==0) // general element
		{
			TREFFTZ(xp,yp,N_SET,T_SET);
		}
		else if(kTSEL==1)// circular hole element
		{ 
			SCHTREF(xp,yp,CLENG,N_SET,T_SET);
		}
		TEMP=(double *)calloc(1*1,sizeof(double));
		DUCLEAN(1,1,TEMP);
		MATMULT(N_SET,c_Ele,1,NTREF,1,TEMP);
		sum=sum+(d_Ele[iNODE]-TEMP[0]);
	}
	*c0=sum/(NNODE*1.0);
	free(N_SET); free(T_SET);
	return;
}