/*
*******************************************************
* Subroutine TREFFTZ                                  *
* - Evaluate Trefftz functions truncted with          * 
*   specified terms number                            *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void TREFFTZ(double sp,double tp,double N_SET[],
			 double T_SET[])
{
	extern int NTREF,NNODE,NDOFN;
	int temp,im,n;
	double remaind,r,s;
	// Check the number of terms of Trefftz functions
	temp=NNODE*NDOFN-1;
	if(NTREF<temp)
	{
		printf("Small number of Trefftz functions!");
		exit(0);
	}
	//
	r=sqrt(pow(sp,2.0)+pow(tp,2.0));
	s=atan2(tp,sp);
	for(im=0;im<NTREF;im++)
	{
		// Determine the order of Ni
		n=(int)(ceil((im+1)/2.0));
		// Justify im is odd or even number
		remaind=fmod(im,2.0);
		if((1+remaind)!=1) // im is even
		{
			N_SET[im]=pow(r,n)*sin(n*s);
			T_SET[0*NTREF+im]=
				n*pow(r,(n-1))*sin((n-1)*s);
			T_SET[1*NTREF+im]=
				n*pow(r,(n-1))*cos((n-1)*s);
		}
		else // im is odd
		{
			N_SET[im]=pow(r,n)*cos(n*s);
			T_SET[0*NTREF+im]=
				n*pow(r,(n-1))*cos((n-1)*s);
			T_SET[1*NTREF+im]=
				-n*pow(r,(n-1))*sin((n-1)*s);
		}
	}
	return;
}

