/*
*******************************************************
* Subroutine ELEPARS                                  *
* - Compute geometric quantities related to element   *
*******************************************************
*/
void ELEPARS(int iELEM,int LNODS[],double COORD[],
			 double ECOOD[],double CenCoord[])
{
	extern int NDIME,NDOFN,NNODE,NEDGE,NODEG;
	int ii,jj,kp,n1;

	for(ii=0;ii<NNODE;ii++)
	{
		kp=LNODS[iELEM*NNODE+ii];
		for(jj=0;jj<NDIME;jj++)
		{
			n1=ii*NDIME+jj;
			ECOOD[n1]=COORD[kp*NDIME+jj];
			CenCoord[jj]=CenCoord[jj]+ECOOD[n1];
		}
	}
	for(jj=0;jj<NDIME;jj++)
	{
		CenCoord[jj]=CenCoord[jj]/NNODE;
	}
	for(ii=0;ii<NNODE;ii++)
	{
		for(jj=0;jj<NDIME;jj++)
		{
			n1=ii*NDIME+jj;
			ECOOD[n1]=ECOOD[n1]-CenCoord[jj];
		}
	}
	return;
}
