/*
*******************************************************
* Subroutine TYPELEM                                  *
* - Local relations of edge and node number for       * 
*   given element                                     *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void TYPELEM(int ELNOD[])
{
	void TELE442(); void TELE843();
	extern int NNODE,NEDGE,NODEG;

	if(NNODE!=NEDGE*(NODEG-1))
	{
		printf("Wrong element type, Check it!\n");
		exit(0);
	}
	if((NEDGE==4)&&(NODEG==2))
	{
		TELE442(ELNOD);
	}
	if((NEDGE==4)&&(NODEG==3))
	{
		TELE843(ELNOD);
	}
	return;
}

/*
      Four-node quadrilateral element
               3             2
               o******<******o
               *             *
               *             *
               v             ^
               *             *
               *             *
               *             *
               o******>******o
               0             1
*/
void TELE442(int ELNOD[])
{
	extern int NODEG;
	// Local relation of edges and nodes
	ELNOD[0*NODEG+0]=0; // edge 1
	ELNOD[0*NODEG+1]=1;
	
	ELNOD[1*NODEG+0]=1; // edge 2
	ELNOD[1*NODEG+1]=2;
	
	ELNOD[2*NODEG+0]=2; // edge 3
	ELNOD[2*NODEG+1]=3;
	
	ELNOD[3*NODEG+0]=3; // edge 4
	ELNOD[3*NODEG+1]=0;
	return;
}


/*
        Eight-node quadrilateral element
               6      5      4
               o******o******o
               *             *
               *             *
             7 o             o 3
               *             *
               *             *
               *             *
               o******o******o
               0      1      2
*/
void TELE843(int ELNOD[])
{
	extern int NODEG;
	// Local relation of edges and nodes
	ELNOD[0*NODEG+0]=0; // edge 1
	ELNOD[0*NODEG+1]=1;
	ELNOD[0*NODEG+2]=2;
	
	ELNOD[1*NODEG+0]=2; // edge 2
	ELNOD[1*NODEG+1]=3;
	ELNOD[1*NODEG+2]=4;
	
	ELNOD[2*NODEG+0]=4; // edge 3
	ELNOD[2*NODEG+1]=5;
	ELNOD[2*NODEG+2]=6;
	
	ELNOD[3*NODEG+0]=6; // edge 4
	ELNOD[3*NODEG+1]=7;
	ELNOD[3*NODEG+2]=0;
	return;
}