/*
*******************************************************
* Subroutine RBFINTP                                  *
* -Compute coefficients of RBF interpolation          *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void RBFINTP(int NPOIN,int NELEM,double COORD[],
			 int LNODS[],int NINTP,double IPCOD[],
			 double bvect[])
{
	void DUCLEAN();
	void LAS_SVD();
	void USERFUN();
	extern int NDIME,NDOFN,NNODE;
	int iP,iD,iE,iN,kP,iT,jT,n1,n,NVARB;
	double *sum0,*FMATX,xi,yi,xj,yj,r,b;
    // Generate interpolation points: node+centroid
	for(iP=0;iP<NPOIN;iP++)
	{
		for(iD=0;iD<NDIME;iD++)
		{
			IPCOD[iP*NDIME+iD]=COORD[iP*NDIME+iD];
		}
	}
	sum0=(double *)calloc(NDIME,sizeof(double));
	for(iE=0;iE<NELEM;iE++)
	{
		n1=NPOIN+iE;
		// Form nodal coordinates of the given element
		DUCLEAN(1,NDIME,sum0);
		for(iD=0;iD<NDIME;iD++)
		{
			for(iN=0;iN<NNODE;iN++)
			{
				kP=LNODS[iE*NNODE+iN];
				sum0[iD]=sum0[iD]+COORD[kP*NDIME+iD];
			}
			IPCOD[n1*NDIME+iD]=sum0[iD]/NNODE;
		}
	}
	// Form coefficient matrix
	NVARB=NINTP*NDOFN;
	FMATX=(double *)calloc(NVARB*NVARB,sizeof(double));
	DUCLEAN(NVARB,NVARB,FMATX);
	for(iT=0;iT<NINTP;iT++)
	{
		xi=IPCOD[iT*NDIME+0];
		yi=IPCOD[iT*NDIME+1];
		// compute right-hand term b
		USERFUN(xi,yi,&b);
		bvect[iT]=b;
        for(jT=0;jT<NINTP;jT++)
		{
			xj=IPCOD[jT*NDIME+0];
			yj=IPCOD[jT*NDIME+1];
			r=sqrt(pow((xi-xj),2)+pow((yi-yj),2));
			// PS: r^(2n-1)
			n=2;
			FMATX[iT*NVARB+jT]=pow(r,(2*n-1));
		}
	}
	// Solve linear algebraic equations
	LAS_SVD(FMATX,bvect,NVARB);
	free(FMATX); free(sum0);
	return;
}
