/*
*******************************************************
* Subroutine HMATRIX                                  *
* - Compute H matrix for each element                 *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void HMATRIX(double ECOOD[],int ELNOD[],int kMATS,
			 double PROPS[],double EHMTX[])
{
	void DUCLEAN();
	void GAUSSQU();
	void QUANGAS();
	void TREFFTZ();
	void MATMULT();
	void MATTRAN();
	extern int NTREF,NDIME,NDOFN,NNODE,NEDGE,NGAUS,
		NPROP,NSTRE;
	double *POSGP,*WEIGP,THICK,EXISP,*CORGS,DVOLU,
		*AMTRX,*SHMTX,*N_SET,*T_SET,*Q_SET,*TQ_SET,*QTN;
	int iEDGE,iGAUS,im,jm,n1,NEVAB;
	
	NEVAB=NNODE*NDOFN;
	// Gaussian point and weight coefficients
	POSGP=(double *)calloc(NGAUS,sizeof(double));
	DUCLEAN(NGAUS,1,POSGP);
	WEIGP=(double *)calloc(NGAUS,sizeof(double));
	DUCLEAN(NGAUS,1,WEIGP);
	GAUSSQU(POSGP,WEIGP);
	// Material properties
	THICK=PROPS[kMATS*NPROP+2];
	// Compute H matrix
	for(iEDGE=0;iEDGE<NEDGE;iEDGE++)
	{
		for(iGAUS=0;iGAUS<NGAUS;iGAUS++)
		{
			EXISP=POSGP[iGAUS];
			//
			CORGS=(double *)calloc(1*NDIME,
				sizeof(double));
			DUCLEAN(1,NDIME,CORGS);
			AMTRX=(double *)calloc(NDOFN*NSTRE,
				sizeof(double));
			DUCLEAN(NDOFN,NSTRE,AMTRX);
			SHMTX=(double *)calloc(NDOFN*NEVAB,
				sizeof(double));
			DUCLEAN(NDOFN,NEVAB,SHMTX);
			QUANGAS(iEDGE,EXISP,ECOOD,ELNOD,CORGS,
				&DVOLU,AMTRX,SHMTX);
			DVOLU=DVOLU*WEIGP[iGAUS];
			if((THICK+1)!=1)
			{
				DVOLU=DVOLU*THICK;
			}
			// Trefftz functions
			N_SET=(double *)calloc(NDOFN*NTREF,
				sizeof(double));
			DUCLEAN(NDOFN,NTREF,N_SET);
			T_SET=(double *)calloc(NSTRE*NTREF,
				sizeof(double));
			DUCLEAN(NSTRE,NTREF,T_SET);
			TREFFTZ(CORGS[0],CORGS[1],kMATS,PROPS,
				N_SET,T_SET);
			//
			Q_SET=(double *)calloc(NDOFN*NTREF,
				sizeof(double));
			DUCLEAN(NDOFN,NTREF,Q_SET);
			MATMULT(AMTRX,T_SET,NDOFN,NSTRE,NTREF,Q_SET);
			//
			TQ_SET=(double *)calloc(NTREF*NDOFN,
				sizeof(double));
			DUCLEAN(NTREF,NDOFN,TQ_SET);
			MATTRAN(Q_SET,NDOFN,NTREF,TQ_SET);
			//
			QTN=(double *)calloc(NTREF*NTREF,
				sizeof(double));
			DUCLEAN(NTREF,NTREF,QTN);
			MATMULT(TQ_SET,N_SET,NTREF,NDOFN,NTREF,QTN);
			for(im=0;im<NTREF;im++)
			{
				for(jm=0;jm<NTREF;jm++)
				{
					n1=im*NTREF+jm;
					EHMTX[n1]=EHMTX[n1]+QTN[n1]*DVOLU;
				}
			}
            free(CORGS); free(AMTRX);
			free(SHMTX); free(N_SET); 
			free(T_SET); free(Q_SET);
			free(TQ_SET); free(QTN);
		}
	}
	free(POSGP); free(WEIGP); 
	return;
}
