/*
*******************************************************
* Subroutine INDISBC                                  *
* - Introduce displacement constraints by the penalty *
*   approach                                          *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void INDISBC(int NEQNS,double PROPS[],double COORD[],
			 int NVFIX,int NOFIX[],int IFPRE[],
			 double PRESC[],double GSTIF[],
			 double GLOAD[],int NINTP,
			 double IPCOD[],double CRBFI[])
{
	void DUCLEAN();
	void PARSOLU();
	extern int NDIME,NDOFN,NSTRE;
	int ii,jj,kp,iGR,n1;
	double temp,CNST,disv,xp,yp,mdisv,*ups,*sps;
	// Decide penalty parameter CNST
	CNST=0.0;
	for(ii=0;ii<NEQNS;ii++)
	{
		for(jj=0;jj<NEQNS;jj++)
		{
			temp=fabs(GSTIF[ii*NEQNS+jj]);
			if(temp>CNST)
			{
				CNST=temp;
			}
		}
	}
	if((CNST+1)==1)
	{
        printf("Singular coefficient matrix GSTIF!");
		exit(0);
    }
	CNST=CNST*1000000.0;
	// Modify GSTIF and GLOAD for specified nodal
	// displacements
	for(ii=0;ii<NVFIX;ii++)
	{
        kp=NOFIX[ii];
		xp=COORD[kp*NDIME+0];
        yp=COORD[kp*NDIME+1];
        for(jj=0;jj<NDOFN;jj++)
		{
            iGR=kp*NDOFN+jj;
            // 1 indicates a constrained DOF
            if(IFPRE[ii*NDOFN+jj]==1)
			{
                disv=PRESC[ii*NDOFN+jj];
				ups=(double *)calloc(NDOFN,
					sizeof(double));
				DUCLEAN(NDOFN,1,ups);
				sps=(double *)calloc(NSTRE,
					sizeof(double));
				DUCLEAN(NSTRE,1,sps);
				PARSOLU(xp,yp,NINTP,IPCOD,CRBFI,
					PROPS,ups,sps);
				// Modify generalized displacement BC
                mdisv=disv-ups[jj];
				n1=iGR*NEQNS+iGR;
                GSTIF[n1]=GSTIF[n1]+CNST;
                GLOAD[iGR]=GLOAD[iGR]+CNST*mdisv;
            }
        }
    }
	return;
}