/*
*******************************************************
* Subroutine LSSOLVR, EQUIL                           *
* - Gaussian Elimination with column pivoting for     *
*   solving Ax=b                                      *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void LSSOLVR(double a[],double b[],int n)
{
	void EQUIL();
	int i,j,k,io,p;
	double d,t;
	// Equilibrium treatment
	EQUIL(a,b,n);
	// Forward Elimination
	for(k=0;k<=n-2;k++)
	{
		d=0.0;
		//select column pivot
		for(i=k;i<n;i++)
		{
			t=a[i*n+k];
			if(fabs(t)>d)
			{
				d=t;
				io=i;
			}
		}
		//if((fabs(d)+1)==1)
		if(fabs(d)<1e-25)
		{
			printf("%dth column is zero,Fail!\n",k);
			exit(0);
		}
		if(io!=k)//kк͵ioеԪ//
		{
			for(j=k;j<n;j++)
			{
				t=a[k*n+j];
				a[k*n+j]=a[io*n+j];
				a[io*n+j]=t;
			}
			t=b[k];
			b[k]=b[io];
			b[io]=t;
		}
		d=a[k*n+k];
		for(j=k+1;j<=n-1;j++)
		{
			p=k*n+j;
			a[p]=a[p]/d;
		}
		b[k]=b[k]/d;
		for(i=k+1;i<=n-1;i++)
		{
			for(j=k+1;j<=n-1;j++)
			{
				p=i*n+j;
				a[p]=a[p]-a[i*n+k]*a[k*n+j];
			}
			b[i]=b[i]-a[i*n+k]*b[k];
		}
	}
	d=a[(n-1)*n+n-1];
	if(fabs(d)+1==1)
	{ 
		printf("Matrix is singular,Fail!\n");
        exit(0);
	}
	b[n-1]=b[n-1]/d;
	for(i=n-2;i>=0;i--)
    { 
		t=0.0;
        for(j=i+1;j<=n-1;j++)
		{
			t=t+a[i*n+j]*b[j];
		}
        b[i]=b[i]-t;
	}
	return;
}

// Equilibrium treatment
void EQUIL(double a[],double b[],int n)
{
	int i,j;
	double temp;
	for(i=0;i<n;i++)
	{
		temp=0.0;
		for(j=0;j<n;j++)
		{
			if(temp<fabs(a[i*n+j]))
			{
				temp=fabs(a[i*n+j]);
			}
		}
		for(j=0;j<n;j++)
		{
			a[i*n+j]=a[i*n+j]/temp;
		}
		b[i]=b[i]/temp;
	}
	return;
}