/*
*******************************************************
* Subroutine PARSOLU                                  *
* -Evaluate approximated particular solutions         *
*  at given point (x,y)                               *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void PARSOLU(double xp,double yp,int NINTP,
			 double IPCOD[],double CRBFI[],
			 double PROPS[],double ups[],double sps[])
{
	extern int NDIME,NDOFN,NTYPE,NPROP;
	double x,y,xj,yj,r,lnr,r1,r2,A1,A2,A3,A4,A5,
		temp1,temp2,u11,u12,u22,s111,s112,s221,
		s222,s121,s122,YOUNG,POISS,THICK,TEXPN,DENST,
		mu,G;
	int jT,n;
    
	// Material properties
	YOUNG=PROPS[0*NPROP+0];
	POISS=PROPS[0*NPROP+1];
	THICK=PROPS[0*NPROP+2];
	TEXPN=PROPS[0*NPROP+3];
	DENST=PROPS[0*NPROP+4];
	G=YOUNG/(2*(1+POISS));
	if(NTYPE==1) //plane stress
	{
		mu=POISS/(1+POISS);
	}
	else if(NTYPE==2)
	{
		mu=POISS;
	}
	// particular solutions
	for(jT=0;jT<NINTP;jT++)
	{
		xj=IPCOD[jT*NDIME+0];
		yj=IPCOD[jT*NDIME+1];
		x=xp-xj;
		y=yp-yj;
		r=sqrt(pow(x,2)+pow(y,2));
		// TPS: r^(2*n)ln(r)
		if(1+r==1)
		{
			r=0;
			lnr=0;
			r1=0;
			r2=0;
		}
		else
		{
			lnr=log(r);
			r1=x/r; // dr/dx
			r2=y/r; // dr/dy
		}
		n=2;
		A1=-(8*pow(n,2)+29*n+27)+8*mu*pow((n+2),2)+
			2*(n+1)*(n+2)*(4*n+7-4*mu*(n+2))*lnr;
		A2=2*(n+1)*(2*n+3)-4*pow((n+1),2)*(n+2)*lnr;
		A3=2*n+3-2*mu*pow((n+2),2)+
			2*(n+1)*(n+2)*(2*mu*n+4*mu-1)*lnr;
		A4=2*(pow(n,2)-2)-4*n*(n+1)*(n+2)*lnr;
		A5=-(2*pow(n,2)+6*n+5)+2*mu*pow((n+2),2)-
			2*(n+1)*(n+2)*(-(2*n+3)+2*mu*(n+2))*lnr;
		temp1=-1.0/(32*G*(1-mu))*pow(r,(2*n+2))
			/(pow((n+1),3)*pow((n+2),2));
		temp2=-1.0/(8*(1-mu))*pow(r,(2*n+1))
			/(pow((n+1),2)*pow((n+2),2));
		
		u11=temp1*(A1+A2*r1*r1);
		u12=temp1*(A2*r1*r2);
		u22=temp1*(A1+A2*r2*r2);
		s111=temp2*(A3*r1+A4*r1*r1*r1+A5*(2*r1));
		s112=temp2*(A3*r2+A4*r1*r1*r2);
		s121=temp2*(A4*r1*r2*r1+A5*r2);
		s122=temp2*(A4*r1*r2*r2+A5*r1);
		s221=temp2*(A3*r1+A4*r2*r2*r1);
		s222=temp2*(A3*r2+A4*r2*r2*r2+A5*(2*r2));
		
		ups[0]=ups[0]+CRBFI[2*jT]*u11 +
			CRBFI[2*jT+1]*u12;
		ups[1]=ups[1]+CRBFI[2*jT]*u12 +
			CRBFI[2*jT+1]*u22;
		sps[0]=sps[0]+CRBFI[2*jT]*s111+
			CRBFI[2*jT+1]*s112;
		sps[1]=sps[1]+CRBFI[2*jT]*s221+
			CRBFI[2*jT+1]*s222;
		sps[2]=sps[2]+CRBFI[2*jT]*s121+
			CRBFI[2*jT+1]*s122;
	}
	return;
}

