/*
*******************************************************
* Subroutine USERFUN                                  *
* - Compute the source value at given point (x,y)     *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void USERFUN(double x, double y,double PROPS[],double GB[],double *T)
{
	extern int NPROP,NTYPE;
	double YOUNG,POISS,THICK,TEXPN,DENST,
		gm,BF1,BF2,DT1,DT2;

	// Material properties
	YOUNG=PROPS[0*NPROP+0];
	POISS=PROPS[0*NPROP+1];
	THICK=PROPS[0*NPROP+2];
	TEXPN=PROPS[0*NPROP+3];
	DENST=PROPS[0*NPROP+4];
	if(NTYPE==1) //plane stress
	{
		gm=YOUNG*TEXPN/(1.0-POISS);
	}
	else if(NTYPE==2)
	{
		gm=YOUNG*TEXPN/(1.0-2*POISS);
	}
	// Body forces
	BF1=0.0; // bx
	BF2=-10.0; // by
	// Temperature change
	*T=0.0;  // T
	DT1=0.0;     // dT/dx
	DT2=0.0;     // dT/dy
	// Generalized body forces
	GB[0]=BF1-gm*DT1;
	GB[1]=BF2-gm*DT2;
	return;
}