/*
*******************************************************
* Mainfunction MAINFUN                                *
* - Call other subroutines                            *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
int NTREF,NTYPE,NNODE,NEDGE,NODEG,NDIME,NDOFN,NSTRE,
NMATS,NPROP,NGAUS;
void main()
{
	void DUCLEAN(); void ITCLEAN(); void INPUTDT();
	void TYPELEM(); void ELEPARS();
	void HMATRIX();	void GMATRIX();	void KMATRIX();
	void ASMSTIF();	void PVECTOR();	void INDISBC();
	void LSSOLVR();	void FIEDNOD();	void FIEDCEN();
	void OPRESUT();
	FILE *fp;
	int NEQNS,NPOIN,NELEM,NVFIX,NPLOD,NDLEG,TNFEG,NEVAB;
	int *MATNO,*LNODS,*NOFIX,*IFPRE,*LODPT,*NEASS,*NOPRS,
		*ELNOD,*TSELE;
	double *COORD,*PRESC,*POINT,*PRESS,*PROPS;
	double *ECOOD,*CenCoord,*EHMTX,*EGMTX,*ESTIF,*GSTIF,
		*GLOAD,*UPOIN,*CECOD,*UCENP,*SCENP,*CHELE,CLENG;
	char dummy[201],TITLE[201],file[81];
	int i,j,k,N,n1,n2,iELEM,kMATS,kTSEL;

	printf("************************************\n");
	printf("        Hybrid Trefftz FEM\n");
	printf("      for 2D elastic problems\n");
	printf("  with general and special elements\n");
    printf("************************************\n");
    /** Input data from file **/
	puts("Input file name < dir:fn.txt >: ");
    gets(file);
	if((fp=fopen(file,"r"))==NULL)
	{
		printf("Warning! Can't open input file\n");
		exit(0);
	}
	// basic parameters
	fgets(dummy,200,fp);
    fgets(TITLE,200,fp);
	fgets(dummy,200,fp);

	fgets(dummy,200,fp);
    fscanf(fp,"%d %d\n",&NTREF,&NTYPE);

	fgets(dummy,200,fp);
    fscanf(fp,"%d %d %d\n",&NNODE,&NEDGE,&NODEG);

	fgets(dummy,200,fp);
    fscanf(fp,"%d %d %d\n",&NDIME,&NDOFN,&NSTRE);

	fgets(dummy,200,fp);
    fscanf(fp,"%d %d %d\n",&NMATS,&NPROP,&NGAUS);

    fgets(dummy,200,fp);
    fscanf(fp,"%d %d %d %d %d\n",&NPOIN,&NELEM,&NVFIX,
		&NPLOD,&NDLEG);

	// element connectivity
	MATNO=(int *)calloc(NELEM,sizeof(int));
	ITCLEAN(NELEM,1,MATNO);
	TSELE=(int *)calloc(NELEM,sizeof(int));
	ITCLEAN(NELEM,1,TSELE);
	CHELE=(double *)calloc(NELEM,sizeof(double));
	DUCLEAN(NELEM,1,CHELE);
    LNODS=(int *)calloc(NELEM*NNODE,sizeof(int));
	ITCLEAN(NELEM,NNODE,LNODS);
	fgets(dummy,200,fp);
	fgets(dummy,200,fp);
	for(i=0;i<NELEM;i++)
	{
		fscanf(fp,"%d %d %d %lf",
			&N,&n1,&TSELE[i],&CHELE[i]);
		MATNO[i]=n1-1;
		for(j=0;j<NNODE;j++)
		{
			fscanf(fp,"%d",&n2);
			LNODS[i*NNODE+j]=n2-1;
		}
		fscanf(fp,"\n");
	}
	// nodal coordinates
	COORD=(double *)calloc(NPOIN*NDIME,
		sizeof(double));
	DUCLEAN(NPOIN,NDIME,COORD);
	fgets(dummy,200,fp);
	fgets(dummy,200,fp);
	for(i=0;i<NPOIN;i++)
	{
		fscanf(fp,"%d",&N);
		for(j=0;j<NDIME;j++)
		{
		    fscanf(fp,"%lf",&COORD[i*NDIME+j]);
		}
		fscanf(fp,"\n");
	}	
	// specified nodal potential/displacement
	NOFIX=(int *)calloc(NVFIX,sizeof(int));
	ITCLEAN(NVFIX,1,NOFIX);
    IFPRE=(int *)calloc(NVFIX*NDOFN,sizeof(int));
	ITCLEAN(NVFIX,NDOFN,IFPRE);
	PRESC=(double *)calloc(NVFIX*NDOFN,
		sizeof(double));
	DUCLEAN(NVFIX,NDOFN,PRESC);
	fgets(dummy,200,fp);
	fgets(dummy,200,fp);
	for(i=0;i<NVFIX;i++)
	{
		fscanf(fp,"%d %d",&N,&n1);
		NOFIX[i]=n1-1;
		for(j=0;j<NDOFN;j++)
		{
			fscanf(fp,"%d",&IFPRE[i*NDOFN+j]);
		}
		for(j=0;j<NDOFN;j++)
		{
			fscanf(fp,"%lf",&PRESC[i*NDOFN+j]);
		}
		fscanf(fp,"\n");
	}
	// specified concentrated loads at nodes
	fgets(dummy,200,fp);
	if(NPLOD>0)
	{
		LODPT=(int *)calloc(NPLOD*1,sizeof(int));
		ITCLEAN(NPLOD,1,LODPT);
		POINT=(double *)calloc(NPLOD*NDOFN,
			sizeof(double));
		DUCLEAN(NPLOD,NDOFN,POINT);
		fgets(dummy,200,fp);
		for(i=0;i<NPLOD;i++)
		{
			fscanf(fp,"%d %d",&N,&n1);
			LODPT[i]=n1-1;
			for(j=0;j<NDOFN;j++)
			{
				fscanf(fp,"%lf",&POINT[i*NDOFN+j]);
			}
			fscanf(fp,"\n");
		}
	}
	// specified distributed edge loads
	fgets(dummy,200,fp);
	if(NDLEG>0)
	{
		NEASS=(int *)calloc(NDLEG*1,sizeof(int));
		ITCLEAN(NDLEG,1,NEASS);
		NOPRS=(int *)calloc(NDLEG*NODEG,sizeof(int));
		ITCLEAN(NDLEG,NODEG,NOPRS);
		TNFEG=NODEG*NDOFN;
		PRESS=(double *)calloc(NDLEG*TNFEG,
			sizeof(double));
		DUCLEAN(NDLEG,TNFEG,PRESS);
		fgets(dummy,200,fp);
		for(i=0;i<NDLEG;i++)
		{
			fscanf(fp,"%d %d",&N,&n1);
			NEASS[i]=n1-1;
			for(j=0;j<NODEG;j++)
			{
				fscanf(fp,"%d",&n2);
				NOPRS[i*NODEG+j]=n2-1;
			}
			for(k=0;k<TNFEG;k++)
			{
				fscanf(fp,"%lf",&PRESS[i*TNFEG+k]);
			}
			fscanf(fp,"\n");
		}
	}
	// material properties
	PROPS=(double *)calloc(NMATS*NPROP,sizeof(double));
	DUCLEAN(NMATS,NPROP,PROPS);
	fgets(dummy,200,fp);
	fgets(dummy,200,fp);
	for(i=0;i<NMATS;i++)
	{
		fscanf(fp,"%d",&N);
		for(j=0;j<NPROP;j++)
		{
			fscanf(fp,"%lf",&PROPS[i*NPROP+j]);
		}
		fscanf(fp,"\n");
	}
	
	/** Establish local relations of nodes and edges **/
	ELNOD=(int *)calloc(NEDGE*NODEG,sizeof(int));
	ITCLEAN(NEDGE,NODEG,ELNOD);
	TYPELEM(ELNOD);
	
	/** Form stiffness matrix **/
	NEQNS=NPOIN*NDOFN;
	GSTIF=(double *)calloc(NEQNS*NEQNS,sizeof(double));
	DUCLEAN(NEQNS,NEQNS,GSTIF);
	for(iELEM=0;iELEM<NELEM;iELEM++)
	{
		kMATS=MATNO[iELEM];
		kTSEL=TSELE[iELEM];
		CLENG=CHELE[iELEM];
		// Compute some quantities related to each element
		ECOOD=(double *)calloc(NNODE*NDIME,sizeof(double));
		DUCLEAN(NNODE,NDIME,ECOOD);
		CenCoord=(double *)calloc(1*NDIME,
			sizeof(double));
		DUCLEAN(1,NDIME,CenCoord);
		ELEPARS(iELEM,LNODS,COORD,ECOOD,CenCoord);
		// Compute H matrix
		EHMTX=(double *)calloc(NTREF*NTREF,
			sizeof(double));
		DUCLEAN(NTREF,NTREF,EHMTX);
		HMATRIX(ECOOD,ELNOD,kMATS,kTSEL,CLENG,
			PROPS,EHMTX);
		// Compute G matrix
		NEVAB=NNODE*NDOFN;
		EGMTX=(double *)calloc(NTREF*NEVAB,
			sizeof(double));
		DUCLEAN(NTREF,NEVAB,EGMTX);
		GMATRIX(ECOOD,ELNOD,kMATS,kTSEL,CLENG,
			PROPS,EGMTX);
		// Compute element stiffness matrix
		ESTIF=(double *)calloc(NEVAB*NEVAB,
			sizeof(double));
		DUCLEAN(NEVAB,NEVAB,ESTIF);
		KMATRIX(EHMTX,EGMTX,ESTIF);
		// Assemble stiffness matrix
		ASMSTIF(iELEM,NEQNS,LNODS,ESTIF,GSTIF);
		free(EHMTX); free(EGMTX); free(ESTIF);
	}
	// Compute equivalent loads
	GLOAD=(double *)calloc(NEQNS*1,sizeof(double));
	DUCLEAN(NEQNS,1,GLOAD);
	PVECTOR(MATNO,PROPS,LNODS,COORD,NDLEG,NEASS,NOPRS,
		PRESS,NPLOD,LODPT,POINT,GLOAD);

	// Introduce constrained displacements
	INDISBC(NEQNS,NVFIX,NOFIX,IFPRE,PRESC,GSTIF,GLOAD);

	// Solve linear system of equations
	LSSOLVR(GSTIF,GLOAD,NEQNS);

	// Output nodal displacement
	UPOIN=(double *)calloc(NPOIN*NDOFN,sizeof(double));
	DUCLEAN(NPOIN,NDOFN,UPOIN);
	FIEDNOD(NPOIN,GLOAD,UPOIN);

	// Compute quantities at centroid of each element
	CECOD=(double *)calloc(NELEM*NDIME,sizeof(double));
	DUCLEAN(NELEM,NDIME,CECOD);
	UCENP=(double *)calloc(NELEM*NDOFN,sizeof(double));
	DUCLEAN(NELEM,NDOFN,UCENP);
	SCENP=(double *)calloc(NELEM*NSTRE,sizeof(double));
	DUCLEAN(NELEM,NSTRE,SCENP);
	FIEDCEN(NELEM,MATNO,TSELE,CHELE,LNODS,COORD,PROPS,
		ELNOD,GLOAD,CECOD,UCENP,SCENP);

	// Output results
	OPRESUT(NPOIN,COORD,UPOIN,NELEM,CECOD,UCENP,SCENP,
		NVFIX,NPLOD,NDLEG);

	free(COORD); free(LNODS); free(MATNO); 
	free(NOFIX); free(IFPRE); free(PRESC); 
	free(PROPS); free(ECOOD); free(CenCoord);
	free(GSTIF); free(GLOAD); free(UPOIN);
	free(CECOD); free(UCENP); free(SCENP);
	printf("------------ Finished ------------\n");
	return;
}