/*
*******************************************************
* Subroutine ASMSTIF                                  *
* - Element stiffness assemble                        *
*******************************************************
Note:
1. Assemble process can be used to other problems 
   directly
2. Full matrix is stored rather than bandwidth form
*/
void ASMSTIF(int iELEM,int NEQNS,int LNODS[],
			 double ESTIF[],double GSTIF[])
{
	extern int NDOFN,NNODE;
	int ii,jj,it,jt,n1,n2,iGR,iLR,jGC,jLC,ip,jp,NEVAB;
	NEVAB=NNODE*NDOFN;

	for(ii=0;ii<NNODE;ii++)
	{
		ip=LNODS[iELEM*NNODE+ii];
		for(it=0;it<NDOFN;it++)
		{
			iGR=NDOFN*ip+it;
			iLR=NDOFN*ii+it;
			for(jj=0;jj<NNODE;jj++) 
			{
				jp=LNODS[iELEM*NNODE+jj];
				for(jt=0;jt<NDOFN;jt++)
				{
					jGC=NDOFN*jp+jt;
					jLC=NDOFN*jj+jt;
					n1=iGR*NEQNS+jGC;
					n2=iLR*NEVAB+jLC;
					GSTIF[n1]=GSTIF[n1]+ESTIF[n2];
				}
			}
		}
	}
	return;
}