/*
*******************************************************
* Subroutine FIEDCEN                                  *
* -Compute related fields at centroid of each element *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void FIEDCEN(int NELEM,int MATNO[],int LNODS[],
			 double COORD[],double PROPS[],int ELNOD[],
			 double ASDIS[],double CECOD[],double UCENP[],
			 double SCENP[])
{
	void ELEPARS(); void DUCLEAN();	void HMATRIX();
	void GMATRIX();	void EDISNOD();	void CMATRIX();
	void RIGIDRV();	void TREFFTZ();	void MATMULT();
	extern int NTREF,NNODE,NDIME,NDOFN,NSTRE;
	int iELEM,kMATS,NEVAB;
	double *ECOOD,*CenCoord,*EHMTX,*EGMTX,*d_Ele,*c_Ele,
		*c0,*N_SET,*T_SET,*GDISP,*GSTRE,xp,yp;
	
	NEVAB=NNODE*NDOFN;
	for(iELEM=0;iELEM<NELEM;iELEM++)
	{
		kMATS=MATNO[iELEM];
		// Compute some quantities related to each element
		ECOOD=(double *)calloc(NNODE*NDIME,sizeof(double));
		DUCLEAN(NNODE,NDIME,ECOOD);
		CenCoord=(double *)calloc(1*NDIME,sizeof(double));
		DUCLEAN(1,NDIME,CenCoord);
		ELEPARS(iELEM,LNODS,COORD,ECOOD,CenCoord);
		// Compute H matrix
		EHMTX=(double *)calloc(NTREF*NTREF,sizeof(double));
		DUCLEAN(NTREF,NTREF,EHMTX);
		HMATRIX(ECOOD,ELNOD,kMATS,PROPS,EHMTX);
		// Compute G matrix
		EGMTX=(double *)calloc(NTREF*NEVAB,sizeof(double));
		DUCLEAN(NTREF,NEVAB,EGMTX);
		GMATRIX(ECOOD,ELNOD,kMATS,PROPS,EGMTX);
		// Nodal displacements
		d_Ele=(double *)calloc(NEVAB,sizeof(double));
		DUCLEAN(NEVAB,1,d_Ele);
		EDISNOD(iELEM,LNODS,ASDIS,d_Ele);
		// Calculate the ce coefficients
		c_Ele=(double *)calloc(NTREF*1,sizeof(double));
		DUCLEAN(NTREF,1,c_Ele);
		CMATRIX(EHMTX,EGMTX,d_Ele,c_Ele);
		// Recover rigid displacement
		c0=(double *)calloc(3*1,sizeof(double));
		DUCLEAN(3,1,c0);
		RIGIDRV(ECOOD,c_Ele,d_Ele,kMATS,PROPS,c0);
		// Compute Trefftz internal fields at central point
		N_SET=(double *)calloc(NDOFN*NTREF,sizeof(double));
		DUCLEAN(NDOFN,NTREF,N_SET);
		T_SET=(double *)calloc(NSTRE*NTREF,sizeof(double));
		DUCLEAN(NSTRE,NTREF,T_SET);
		xp=0;
		yp=0;
		TREFFTZ(xp,yp,kMATS,PROPS,N_SET,T_SET);
		GDISP=(double *)calloc(NDOFN*1,sizeof(double));
		DUCLEAN(NDOFN,1,GDISP);
		GSTRE=(double *)calloc(NSTRE*1,sizeof(double));
		DUCLEAN(NSTRE,1,GSTRE);
		MATMULT(N_SET,c_Ele,NDOFN,NTREF,1,GDISP);
		MATMULT(T_SET,c_Ele,NSTRE,NTREF,1,GSTRE);
		UCENP[iELEM*NDOFN+0]=GDISP[0]+c0[0]+yp*c0[2];
		UCENP[iELEM*NDOFN+1]=GDISP[1]+c0[1]-xp*c0[2];
		SCENP[iELEM*NSTRE+0]=GSTRE[0];
		SCENP[iELEM*NSTRE+1]=GSTRE[1];
		SCENP[iELEM*NSTRE+2]=GSTRE[2];
		// Coordinates of commputing point
		CECOD[iELEM*NDIME+0]=CenCoord[0]+xp;
		CECOD[iELEM*NDIME+1]=CenCoord[1]+yp;
	}
	free(ECOOD); free(CenCoord); free(EHMTX);
	free(EGMTX); free(d_Ele); free(c_Ele);
	free(N_SET); free(T_SET); free(GDISP);
	free(GSTRE);
}
