/*
*******************************************************
* Subroutine RIGIDRV                                  *
* - Recovery of rigid body motion                     *
*******************************************************
*/
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
void RIGIDRV(double ECOOD[],double c_Ele[],
			 double d_Ele[],int kMATS,double PROPS[],
			 double rvect[])
{
	void DUCLEAN();
	void MATMULT();
	void TREFFTZ();
	void LSSOLVR();
	extern int NTREF,NDIME,NDOFN,NNODE,NSTRE;
	double x1,x2,*N_SET,*T_SET,*RMATX,du1,du2,*u;
	int iNODE;
    
	RMATX=(double *)calloc(3*3,sizeof(double));
	DUCLEAN(3,3,RMATX);
	N_SET=(double *)calloc(NDOFN*NTREF,sizeof(double));
	T_SET=(double *)calloc(NSTRE*NTREF,sizeof(double));
	for(iNODE=0;iNODE<NNODE;iNODE++)
	{
		x1=ECOOD[iNODE*NDIME+0];
		x2=ECOOD[iNODE*NDIME+1];
		DUCLEAN(NDOFN,NTREF,N_SET);
		DUCLEAN(NSTRE,NTREF,T_SET);
		TREFFTZ(x1,x2,kMATS,PROPS,N_SET,T_SET);
		u=(double *)calloc(NDOFN*1,sizeof(double));
		DUCLEAN(NDOFN,1,u);
		MATMULT(N_SET,c_Ele,NDOFN,NTREF,1,u);
		
		du1=d_Ele[iNODE*2  ]-u[0];
		du2=d_Ele[iNODE*2+1]-u[1];
		rvect[0]=rvect[0]+du1;
		rvect[1]=rvect[1]+du2;
		rvect[2]=rvect[2]+x2*du1-x1*du2;
		
		RMATX[0*3+2]=RMATX[0*3+2]+x2;
		RMATX[1*3+2]=RMATX[1*3+2]-x1;
		RMATX[2*3+2]=RMATX[2*3+2]+(pow(x1,2)+pow(x2,2));
	}
	RMATX[2*3+0]=RMATX[0*3+2];
	RMATX[2*3+1]=RMATX[1*3+2];
	RMATX[0*3+0]=NNODE;
	RMATX[1*3+1]=NNODE;
    // R*c0=r
	LSSOLVR(RMATX,rvect,3);
    // after this the rvect stores c0
	free(N_SET); free(T_SET), free(RMATX);
	return;
}
