function [UNODE]=FIEDNOD(NPOIN,ASDIS)
% Generate nodal generalized displacement field
% Input parameters:
%   NPOIN: Number of nodes in domain
%   ASDIS: Nodal generalized displacement field in DOF order
% Output parameters:
%   UNODE: Nodal generalized displacement field
% ***********************************
global NDOFN NDIME;

UNODE=zeros(NPOIN, NDOFN);
for iPOIN=1: NPOIN
    NRT=(iPOIN-1)*NDOFN;
    for iDOFN=1: NDOFN
        NR=NRT+iDOFN;
        UNODE(iPOIN, iDOFN)=ASDIS(NR);
    end
end