function [SHAPE,DSHAP]=SHAPFUN(EXISP)
% Shape functions and its derivatives for 1D line element
% Input parameters:
%   EXISP: coordinates at Gaussian samples
% Output parameters:
%   SHAPE: vector of shape functions
%   DSHAP: vector of derivatives of shape functions
%              dN/ds
% **********************************
global NODEG;

if NODEG==2
    SH1 =(1-EXISP)/2;
    SH2 =(1+EXISP)/2;
    DSH1=-0.5;
    DSH2= 0.5;

    SHAPE=[SH1,SH2];
    DSHAP=[DSH1,DSH2];
elseif NODEG==3
    SH1 =-EXISP*(1-EXISP)/2;
    SH2 = 1-EXISP^2;
    SH3 = EXISP*(1+EXISP)/2;
    DSH1=-0.5+EXISP;
    DSH2=-2*EXISP;
    DSH3= 0.5+EXISP;

    SHAPE=[SH1,SH2,SH3];
    DSHAP=[DSH1,DSH2,DSH3];
end