function [ELNOD]=TELE442
% Element properties of four-node quadrature element
%               4             3
%               o******<******o
%               *             *
%               *             *
%               v             ^
%               *             *
%               *             *
%               *             *
%               o******>******o
%               1             2
global NEDGE NODEG;

% Local relation of edges and nodes
ELNOD=zeros(NEDGE, NODEG);
ELNOD(1, 1)=1; % edge 1
ELNOD(1, 2)=2;

ELNOD(2, 1)=2; % edge 2
ELNOD(2, 2)=3;

ELNOD(3, 1)=3; % edge 3
ELNOD(3, 2)=4;

ELNOD(4, 1)=4; % edge 4
ELNOD(4, 2)=1;