function [d_Ele]=EDISNOD(iELEM,LNODS,ASDIS)
% Identify the nodal displacements of the specified
% element
% Input parameters:
%   iELEM: Specified element
%   LNODS: Element connectivity
%   ASDIS: Nodal generalized displacement field in DOF
%          order
% Output parameters:
%   d_Ele: Nodal generalized displacement field in
%          specified element
% ***********************************
global NDIME NDOFN NNODE;

NEVAB=NNODE*NDOFN;
d_Ele=zeros(NEVAB,1);
for iNODE=1:NNODE
    kPOIN=LNODS(iELEM,iNODE);
    NR=(kPOIN-1)*NDOFN;
    nr=(iNODE-1)*NDOFN;
    for iDOFN=1:NDOFN
        NPOSN=NR+iDOFN;
        iEVAB=nr+iDOFN;
        d_Ele(iEVAB)=ASDIS(NPOSN);
    end
end