function [UNODE]=FIEDNOD(NPOIN,COORD,ASDIS,NINTP,...
    IPCOD,CRBFI)
% Generate nodal generalized displacement field
% Input parameters:
%   NPOIN: Number of nodes in domain
%   COORD: Coordinates of nodes
%   ASDIS: Nodal generalized displacement field in DOF
%          order
%   NINTP: Number of RBF interpolation points
%   IPCOD: Coordinates of RBF interpolation points
%   CRBFI: Coefficient of RBF interpolation
% Output parameters:
%   UNODE: Nodal generalized displacement field
% ***********************************
global NDOFN NDIME;

UNODE=zeros(NPOIN,NDOFN);
for iPOIN=1:NPOIN
    xp=COORD(iPOIN,1);
    yp=COORD(iPOIN,2);
    % particular solution
    [ups,sps]=PARSOLU(xp,yp,NINTP,IPCOD,CRBFI);
    % full solution
    NRT=(iPOIN-1)*NDOFN;
    for iDOFN=1: NDOFN
        NR=NRT+iDOFN;
        UNODE(iPOIN,iDOFN)=ASDIS(NR)+ups(iDOFN);
    end
end