function [ups,sps]=PARSOLU(xp,yp,NINTP,IPCOD,CRBFI)
% Evaluate approximated particular solutions at given
% point (xp,yp)
% Input parameters:
%   xp,yp:  Coordinates of computing point
%   NINTP:  Number of interpolation points
%   IPCOD:  Coordinates of interpolation points
%   CRBFI:  Coefficient of RBF interpolation
% Output parameters:
%   ups  :  displacement particular solutions
%   sps  :  stress particular solutions
% ************************************************
global NDIME NDOFN;

up=0;
uxp=0;
uyp=0;
for jINTP=1:NINTP
    xj=IPCOD(jINTP,1);
    yj=IPCOD(jINTP,2);
    x=xp-xj;
    y=yp-yj;
    r=sqrt(x^2+y^2);
    % PS: r^(2n-1)
    n=2;
    Phi =r^(2*n+1)/((2*n+1)^2);
    Phix=r^(2*n-1)/(2*n+1)*x;
    Phiy=r^(2*n-1)/(2*n+1)*y;
    
    up =up +CRBFI(jINTP)*Phi;
    uxp=uxp+CRBFI(jINTP)*Phix;
    uyp=uyp+CRBFI(jINTP)*Phiy;
end
ups=up;
sps=[uxp;uyp];