function [c0]=RigidRecover(ECOOD,c_Ele,d_Ele)
% Recovery of rigid body motion
% Input parameters:
%   ECOOD: Coordinates of element nodes
%   c_Ele: Coefficients of Trefftz interpolation
%   d_Ele: Displacement field at element nodes
% Output parameters:
%   c0: Rigid body motion term
% **********************************

global NNODE;
sum=0;
for iNODE=1: NNODE
    xp1=ECOOD(iNODE, 1);
    yp1=ECOOD(iNODE, 2);
    [N_SET, T_SET]=TREFFTZ(xp1, yp1);
    sum=sum+(d_Ele(iNODE)-N_SET*c_Ele);
end
c0=sum/NNODE;