function [ELNOD]=TELE843
% Element properties of eight-node quadrature element
%               7      6      5
%               o******o******o
%               *             *
%               *             *
%             8 o             o 4
%               *             *
%               *             *
%               *             *
%               o******o******o
%               1      2      3
global NEDGE NODEG;

% Local relation of edges and nodes
ELNOD=zeros(NEDGE, NODEG);
ELNOD(1, 1)=1; % edge 1
ELNOD(1, 2)=2;
ELNOD(1, 3)=3;

ELNOD(2, 1)=3; % edge 2
ELNOD(2, 2)=4;
ELNOD(2, 3)=5;

ELNOD(3, 1)=5; % edge 3
ELNOD(3, 2)=6;
ELNOD(3, 3)=7;

ELNOD(4, 1)=7; % edge 4
ELNOD(4, 2)=8;
ELNOD(4, 3)=1;