function [GBFOR,TEMPR]=USERFUN(x,y,PROPS)
% Compute the source value at given point (x,y)
% Input parameters:
%   x, y :  Coordinates of computing point
% Output parameters:
%   b    :  Value of generalized body forces at point (x,y)
% ************************************************
global NTYPE;

% Material properties
YOUNG=PROPS(1,1);
POISS=PROPS(1,2);
THICK=PROPS(1,3);
TEXPN=PROPS(1,4);
DENST=PROPS(1,5);
%
if NTYPE==1 %plane stress
    gm=YOUNG*TEXPN/(1-POISS);
elseif NTYPE==2
    gm=YOUNG*TEXPN/(1-2*POISS);
end
    
% Body forces
BODYF(1)=0; % bx
BODYF(2)=-10;  % by
% Temperature change
TEMPR=0;    % T
DTEMP(1)=0; % dT/dx
DTEMP(2)=0; % dT/dy
% Generalized body forces
GBFOR=zeros(2,1);
GBFOR(1)=BODYF(1)-gm*DTEMP(1);
GBFOR(2)=BODYF(2)-gm*DTEMP(2);