function [GK]=ASMSTIF(iELEM, NNODE, LNODS, KE, GK)
% assemble element stiffness and right term
%
% Note: 
%	1.assemble process can be used to other problems directly
%   2.Full matrix is stored instead of bandwidth form
%
global NDOFN;

for iNODE=1:NNODE
    iPOIN=LNODS(iELEM,iNODE);
    for iDOFN=1:NDOFN
        iGROW=NDOFN*(iPOIN-1)+iDOFN; % global row location
        iLROW=NDOFN*(iNODE-1)+iDOFN; % local row location
        for jNODE=1:NNODE
            jPOIN=LNODS(iELEM,jNODE);
            for jDOFN=1:NDOFN
                jGCOL=NDOFN*(jPOIN-1)+jDOFN; % global column location
                jLCOL=NDOFN*(jNODE-1)+jDOFN;% local column location
                GK(iGROW,jGCOL)=GK(iGROW,jGCOL)+KE(iLROW,jLCOL);
            end
        end
    end
end
clear KE;