function [ECOOD,CenCoord]=ELEPARS(iELEM,LNODS,COORD)
% Generate coordinates of nodes and central point in specified element
% Input parameters:
%   iELEM: Specified element
%   LNODS: Element connectivity
%   COORD: Coordinates of nodes
% Output parameters:
%   ECOOD: Coordinates of nodes of specified element
%   CenCoord: Coordinates of centroid of specified element
% ***********************************
global NDIME NDOFN NNODE NEDGE NODEG;

% Compute nodal coordinates of the given element
ECOOD=zeros(NNODE,NDIME);
for iNODE=1:NNODE
    kPOIN=LNODS(iELEM,iNODE);
    ECOOD(iNODE,:)=COORD(kPOIN,:);
end
% Coordinates of central point
CenCoord=sum(ECOOD)/NNODE;
% Form local element coordinates system
ECOOD(:,1)=ECOOD(:,1)-CenCoord(1);
ECOOD(:,2)=ECOOD(:,2)-CenCoord(2);