function [GK,GP]=INDISBC(NEQNS,NVFIX,NOFIX,IFPRE,PRESC,GK,GP)
% Modify global stiffness matrix GK and load vector GP according to
% specified nodal potentials
% Penalty approach: add a large number

global NDOFN;

if NVFIX>0
    % Decide penalty parameter CNST
    CNST=max(max(abs(GK)));
    if CNST+1==1
        error(' ** Error: Singular coefficient matrix GK!');
    end
    CNST=CNST*1000000;
    % Modify GK and GP for specified nodal displacements
    for iVFIX=1:NVFIX
        kPOIN=NOFIX(iVFIX);
        for iDOFN=1: NDOFN
            NR=(kPOIN-1)*NDOFN+iDOFN;
            ii=IFPRE(iVFIX, iDOFN);
            % unit value indicates a constrained degree of freedom
            if ii==1
                disv=PRESC(iVFIX, iDOFN);
                GK(NR, NR)=GK(NR, NR)+CNST;
                GP(NR)=GP(NR)+CNST*disv;
            end
        end
    end
end