function [x]=LSSOLVR(A, b, n)
% Solve Linear system of equations A x = b
%
% n is the number of column or row
% A : n by n
% b : n by 1 

% Equilibration treatment
[A, b]=EQUIL(A, b, n);
% Condition number
condnum=cond(A);
% MATLAB Command
x=A\b;
% Residual norm
resnorm=norm(A*x-b);
disp(['Condition number = ',num2str(condnum)]);
disp(['Residual  norm   = ',num2str(resnorm)]);


% --------------------------------------------
function [A, b]=EQUIL(A, b, m)
% Equilibration treatment of Ax=b
%
% Determine the maximum element in each row and store them in column vector
% temp: m by 1
temp=(max(abs(A')))';
if min(temp)+1==1
    error(' **** Warning: Matrix has the bad row whose all components are zero');
end
% Elements in each row divide the maximum element
for ii=1: m
    A(ii,:)=A(ii,:)/temp(ii);
end
b=b./temp;