function [c0]=RIGIDRV(ECOOD,c_Ele,d_Ele,kMATS,...
    kTSEL,CLENG,PROPS)
% Rigid body motion recovery
global NNODE;

RMATX=zeros(3,3);
rvect=zeros(3,1);
for iNODE=1:NNODE
    x1=ECOOD(iNODE,1);
    x2=ECOOD(iNODE,2);
    if kTSEL==0 % general element
        [N_SET,T_SET]=TREFFTZ(x1,x2,kMATS,PROPS);
    elseif kTSEL==1 % special circular hole element
        [N_SET,T_SET]=SCHTREF(x1,x2,kMATS,CLENG,PROPS);
    end
    u=N_SET*c_Ele;
    
    du1=d_Ele(iNODE*2-1)-u(1);
    du2=d_Ele(iNODE*2  )-u(2);
    rvect(1)=rvect(1)+du1;
    rvect(2)=rvect(2)+du2;
    rvect(3)=rvect(3)+x2*du1-x1*du2;
    
    RMATX(1,3)=RMATX(1,3)+x2;
    RMATX(2,3)=RMATX(2,3)-x1;
    RMATX(3,3)=RMATX(3,3)+(x1^2+x2^2);
end
RMATX(3,1)=RMATX(1,3);
RMATX(3,2)=RMATX(2,3);
RMATX(1,1)=NNODE;
RMATX(2,2)=NNODE;

c0=RMATX\rvect;

clear N_SET T_SET RMATX rvect;