function [EHMTX]=HMATRIX(ECOOD,ELNOD,kMATS,PROPS)
% Compute H matrix for a given element
global NTREF NDIME NDOFN NNODE NEDGE NGAUS;

% Gaussian point and weight coefficients
[POSGP, WEIGP]=GAUSSQU(NGAUS);
% Material properties
THICK=PROPS(kMATS,3);
EHMTX=zeros(NTREF,NTREF);
for iEDGE=1:NEDGE
    for iGAUS=1:NGAUS
        EXISP=POSGP(iGAUS);
        [CORGS,DVOLU,AMTRX,SHMTX]=QUANGAS(iEDGE,...
            EXISP,ECOOD,ELNOD);
        DVOLU=DVOLU*WEIGP(iGAUS);
        if THICK+1~=1
            DVOLU=DVOLU*THICK;
        end
        [N_SET,T_SET]=TREFFTZ(CORGS(1),CORGS(2),...
            kMATS,PROPS);
        Q_SET=AMTRX*T_SET;
        QTN=Q_SET'*N_SET;
        for im=1:NTREF
            for jm=1:NTREF
                EHMTX(im,jm)=EHMTX(im,jm)+...
                    QTN(im,jm)*DVOLU;
            end
        end
    end
end
clear Q_SET QTN N_SET T_SET POSGP WEIGP AMTRX SHMTX;